/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.batchprocess;

import java.io.File;
import java.util.List;

import blanco.batchprocess.stringgroup.BlancoBatchProcessSupportedLangStringGroup;
import blanco.batchprocess.valueobject.BlancoBatchProcessInparameterListStructure;
import blanco.batchprocess.valueobject.BlancoBatchProcessStructure;
import blanco.cg.BlancoCgObjectFactory;
import blanco.cg.transformer.BlancoCgTransformerFactory;
import blanco.cg.valueobject.BlancoCgClass;
import blanco.cg.valueobject.BlancoCgField;
import blanco.cg.valueobject.BlancoCgMethod;
import blanco.cg.valueobject.BlancoCgSourceFile;
import blanco.commons.util.BlancoJavaSourceUtil;
import blanco.commons.util.BlancoNameAdjuster;
import blanco.commons.util.BlancoStringUtil;

/**
 * ob`ۃNXWJ܂B
 */
class BlancoBatchProcessExpandBatchProcess {
    /**
     * o͑ΏۂƂȂvO~OB
     */
    private int fTargetLang = BlancoBatchProcessSupportedLangStringGroup.NOT_DEFINED;

    /**
     * ^CpbP[WB
     */
    private String fRuntimePackage = null;

    /**
     * IɗpblancoCgpt@NgB
     */
    private BlancoCgObjectFactory fCgFactory = null;

    /**
     * IɗpblancoCgp\[Xt@CB
     */
    private BlancoCgSourceFile fCgSourceFile = null;

    /**
     * IɗpblancoCgpNXB
     */
    private BlancoCgClass fCgClass = null;

    /**
     * WꂽɁA\[XR[h܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     * @param argRuntimePackage
     *            ^CpbP[WBnullђ0̏̕ꍇ͒`ƂɃ^CNX𐶐B
     * @param argTargetLang
     *            o͑ΏۃvO~OB
     * @param argDirectoryTarget
     *            \[XR[h̏o͐tH_B
     */
    public void expandSourceFile(
            final BlancoBatchProcessStructure argProcessStructure,
            final String argRuntimePackage, final int argTargetLang,
            final File argDirectoryTarget) {
        fRuntimePackage = argRuntimePackage;
        fTargetLang = argTargetLang;

        // ]ƌ݊邽߁A/mainTutH_ɏo͂܂B
        final File fileBlancoMain = new File(argDirectoryTarget
                .getAbsolutePath()
                + "/main");

        fCgFactory = BlancoCgObjectFactory.getInstance();
        fCgSourceFile = fCgFactory.createSourceFile(argProcessStructure
                .getPackage(), "̃\[XR[h blanco FrameworkɂĎĂ܂B");
        fCgClass = fCgFactory.createClass("Abstract"
                + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix()),
                BlancoStringUtil.null2Blank(argProcessStructure
                        .getDescription()));
        fCgSourceFile.getClassList().add(fCgClass);

        fCgClass.setAbstract(true);

        expandField(argProcessStructure);
        expandMethodMain(argProcessStructure);
        expandMethodProcess(argProcessStructure);
        expandMethodExecute(argProcessStructure);
        expandMethodUsage(argProcessStructure);

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            fCgSourceFile
                    .getImportList()
                    .add(
                            getBlancoBatchProcessExceptionClassName(argProcessStructure));

            if (BlancoStringUtil.null2Blank(fRuntimePackage).length() == 0) {
                // `ƂɓpbP[WɃ^CNX𐶐B
                new BlancoBatchProcessExpandException().expandSourceFile(
                        argProcessStructure.getPackage(), fTargetLang,
                        argDirectoryTarget);
            }
        }

        switch (fTargetLang) {
        case BlancoBatchProcessSupportedLangStringGroup.JAVA:
            BlancoCgTransformerFactory.getJavaSourceTransformer().transform(
                    fCgSourceFile, fileBlancoMain);
            break;
        case BlancoBatchProcessSupportedLangStringGroup.CS:
            BlancoCgTransformerFactory.getCsSourceTransformer().transform(
                    fCgSourceFile, fileBlancoMain);
            break;
        default:
            break;
        }
    }

    /**
     * tB[hWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandField(
            final BlancoBatchProcessStructure argProcessStructure) {

        {
            final BlancoCgField field = fCgFactory.createField("END_SUCCESS",
                    "int", "IB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput().getEndSuccess());
        }

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            final BlancoCgField field = fCgFactory.createField(
                    "END_BATCHPROCESS_EXCEPTION", "int",
                    "ob`OIBIBatchProcessExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput()
                    .getEndBatchProcessException());
        }

        {
            final BlancoCgField field = fCgFactory.createField(
                    "END_ILLEGAL_ARGUMENT", "int",
                    "ُ͈IBIjava.lang.IllegalArgumentExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput()
                    .getEndIllegalArgument());
        }

        {
            final BlancoCgField field = fCgFactory
                    .createField(
                            "END_ERROR",
                            "int",
                            "ُIBob`̏JnɎsꍇAѓIjava.lang.Error܂java.lang.RuntimeExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput().getEndError());
        }
    }

    /**
     * p[^Xg𕶎̌`Ŏ擾܂B
     * 
     * @param argProcessStructure
     * @return
     */
    private String getParameterListAsString(
            final BlancoBatchProcessStructure argProcessStructure) {
        String parameters = "";
        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            if (index != 0) {
                parameters += ", ";
            }
            parameters += "arg"
                    + BlancoNameAdjuster.toClassName(inparam.getName());
        }

        return parameters;
    }

    /**
     * main \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodMain(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("main",
                "Gg|CgB");
        fCgClass.getMethodList().add(method);

        method.setStatic(true);
        method.setFinal(true);
        method.getParameterList().add(
                fCgFactory.createParameter("args", "java.lang.String[]",
                        "R\[pꂽB"));

        final List listLine = method.getLineList();
        listLine.add("// Abstract" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "NXp" + argProcessStructure.getPackage() + "pbP[W"
                + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "NX쐬܂B");
        listLine.add("Abstract" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + " batchProcess = new " + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "();");
        listLine.add("");
        listLine.add("// ob`̈B");
        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            String wrkDefault = inparam.getDefault();
            if (wrkDefault == null) {
                wrkDefault = "null";
            } else {
                wrkDefault = "\""
                        + BlancoJavaSourceUtil
                                .escapeStringAsJavaSource(wrkDefault) + "\"";
            }
            listLine.add("String arg"
                    + BlancoNameAdjuster.toClassName(inparam.getName()) + " = "
                    + wrkDefault + ";");
        }
        listLine.add("");
        listLine.add("boolean isNeedUsage = false;");
        listLine.add("");
        listLine.add("// R}hC̉͂Ȃ܂B");
        listLine.add("for (int index = 0; index < args.length; index++) {");
        listLine.add("String arg = args[index];");
        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            String line = "";
            if (index == 0) {
            } else {
                line += "} else ";
            }
            line += "if (arg.startsWith(\"-" + inparam.getName() + "=\")) {";
            listLine.add(line);
            listLine.add("arg"
                    + BlancoNameAdjuster.toClassName(inparam.getName())
                    + " = arg.substring(" + (inparam.getName().length() + 2)
                    + ");");
        }
        listLine
                .add("} else if (arg.equals(\"-?\") || arg.equals(\"-help\")) {");
        listLine.add("usage();");
        listLine.add("System.exit(END_SUCCESS);");
        listLine.add("} else {");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ̓p[^[\" + arg + \"]͖܂B\");");
        listLine.add("isNeedUsage = true;");
        listLine.add("}");
        listLine.add("}");
        listLine.add("");
        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            if (inparam.getIsRequire()) {
                listLine.add("if (arg"
                        + BlancoNameAdjuster.toClassName(inparam.getName())
                        + " == null) {");
                listLine.add("System.out.println(\""
                        + argProcessStructure.getName()
                        + BlancoStringUtil.null2Blank(argProcessStructure
                                .getSuffix()) + ": JnsBK{̓̓p[^["
                        + inparam.getName() + "]ݒ肳Ă܂B\");");
                listLine.add("usage();");
                listLine.add("System.exit(END_ERROR);");
                listLine.add("}");
            }
        }
        listLine.add("");
        listLine.add("if (isNeedUsage) {");
        listLine.add("usage();");
        listLine.add("}");
        listLine.add("");
        listLine.add("int retCode = batchProcess.execute("
                + getParameterListAsString(argProcessStructure) + ");");
        listLine.add("");
        listLine.add("// IR[h߂܂B");
        listLine.add("// ӁFSystem.exit()ĂяoĂ_ɒӂĂB");
        listLine.add("System.exit(retCode);");
    }

    /**
     * execute \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodExecute(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("execute",
                "ob`sۂɌĂяo܂B");
        fCgClass.getMethodList().add(method);

        method.setFinal(true);
        expandParameterList(argProcessStructure, method);
        method.setReturn(fCgFactory.createReturn("int", "ob`̏IR[hB"
                + BlancoStringUtil.null2Blank(argProcessStructure.getOutput()
                        .getDescription())));

        final List listLine = method.getLineList();

        listLine.add("try {");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": begin\");");
        listLine.add("");
        listLine.add("// ob`̖{̂s܂B");
        listLine.add("int retCode = process("
                + getParameterListAsString(argProcessStructure) + ");");
        listLine.add("");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": end (\" + retCode + \")\");");
        listLine.add("return retCode;");

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            listLine.add("} catch (BlancoBatchProcessException ex) {");
            listLine.add("System.out.println(\""
                    + argProcessStructure.getName()
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix())
                    + ": ob`O܂Bob`𒆒f܂B:\" + ex.toString());");
            listLine.add("// ob`OIB");
            listLine.add("return END_BATCHPROCESS_EXCEPTION;");
        }
        listLine.add("} catch (IllegalArgumentException ex) {");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ͗O܂Bob`𒆒f܂B:\" + ex.toString());");
        listLine.add("// ُ͈IB");
        listLine.add("return END_ILLEGAL_ARGUMENT;");
        listLine.add("} catch (RuntimeException ex) {");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ^CO܂Bob`𒆒f܂B:\" + ex.toString());");
        listLine.add("ex.printStackTrace();");
        listLine.add("// ُIB");
        listLine.add("return END_ERROR;");
        listLine.add("} catch (Error er) {");
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ^CG[܂Bob`𒆒f܂B:\" + er.toString());");
        listLine.add("er.printStackTrace();");
        listLine.add("// ُIB");
        listLine.add("return END_ERROR;");
        listLine.add("}");
    }

    /**
     * process \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodProcess(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("process",
                "ob`eLq郁\bhB");
        fCgClass.getMethodList().add(method);

        method.getLangDoc().getDescriptionList().add("̃\bhɎۂ̏eLq܂B");
        expandParameterList(argProcessStructure, method);
        method.setAbstract(true);
        method.setReturn(fCgFactory.createReturn("int", "ob`̏IR[hB"
                + BlancoStringUtil.null2Blank(argProcessStructure.getOutput()
                        .getDescription())));
    }

    /**
     * execute \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodUsage(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("usage",
                "g̐B");
        fCgClass.getMethodList().add(method);

        method.setStatic(true);
        method.setFinal(true);

        final List listLine = method.getLineList();
        listLine.add("System.out.println(\"" + argProcessStructure.getName()
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": Usage:\");");
        {
            String strArg = "System.out.println(\"  java "
                    + argProcessStructure.getPackage()
                    + "."
                    + argProcessStructure.getName()
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix());
            for (int index = 0; index < argProcessStructure.getListField()
                    .size(); index++) {
                final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                        .getListField().get(index);
                strArg += " -" + inparam.getName() + "=l" + (index + 1) + "";
            }
            strArg += "\");";
            listLine.add(strArg);
        }

        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            listLine.add("System.out.println(\"    -" + inparam.getName()
                    + "\");");
            if (inparam.getDefault() != null) {
                listLine.add("System.out.println(\"      ["
                        + BlancoJavaSourceUtil.escapeStringAsJavaSource(inparam
                                .getDescription()) + "]\");");
            }
            if (inparam.getIsRequire()) {
                listLine.add("System.out.println(\"      K{p[^B\");");
            }
            if (inparam.getDefault() != null) {
                listLine.add("System.out.println(\"      ftHgl["
                        + BlancoJavaSourceUtil.escapeStringAsJavaSource(inparam
                                .getDefault()) + "]\");");
            }
        }
        listLine.add("System.out.println(\"    -? , -help\");");
        listLine.add("System.out.println(\"      [g\܂B]\");");
    }

    /**
     * p[^̃XgWJ܂B
     * 
     * @param argProcessStructure
     * @param method
     */
    private void expandParameterList(
            final BlancoBatchProcessStructure argProcessStructure,
            final BlancoCgMethod method) {
        for (int index = 0; index < argProcessStructure.getListField().size(); index++) {
            final BlancoBatchProcessInparameterListStructure inparam = (BlancoBatchProcessInparameterListStructure) argProcessStructure
                    .getListField().get(index);
            method.getParameterList().add(
                    fCgFactory.createParameter(
                            "arg"
                                    + BlancoNameAdjuster.toClassName(inparam
                                            .getName()), "java.lang.String",
                            inparam.getDescription()));
        }
    }

    private String getBlancoBatchProcessExceptionClassName(
            final BlancoBatchProcessStructure argProcessStructure) {
        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() == 0) {
            throw new IllegalArgumentException(
                    "ob`OIOFFł̂ɁABlancoBatchProcessException NX擾̃\bhĂяo܂BĂ܂");
        }

        if (BlancoStringUtil.null2Blank(fRuntimePackage).length() == 0) {
            return argProcessStructure.getPackage()
                    + ".BlancoBatchProcessException";
        } else {
            return fRuntimePackage + ".BlancoBatchProcessException";
        }
    }

    /**
     * vO~Oꏈnɍ String ^̖̂擾܂B
     * 
     * ^̓ǂݑւB
     * 
     * @return
     */
    private final String getTypeString() {
        switch (fTargetLang) {
        case BlancoBatchProcessSupportedLangStringGroup.JAVA:
        default:
            return "java.lang.String";
        case BlancoBatchProcessSupportedLangStringGroup.CS:
            return "string";
        }
    }

    /**
     * vO~Oꏈnɍ \bh̖Oό`Ȃ܂B
     * 
     * \bh̓ǂݑւB
     * 
     * @return
     */
    private final String getMethodName(final String argMethodName) {
        switch (fTargetLang) {
        case BlancoBatchProcessSupportedLangStringGroup.JAVA:
        default:
            return argMethodName;
        case BlancoBatchProcessSupportedLangStringGroup.CS:
            return BlancoNameAdjuster.toUpperCaseTitle(argMethodName);
        }
    }
}
